require 'uu/os/rest/dto'
require 'uu/os/uesuri'


# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Artifact State Template.
    module ArtifactStateTemplate
      # @see ArtifactStateTemplate#create
      class ArtifactStateTemplateCreate < UU::OS::REST::DTO

        # @see ArtifactStateTemplate#create
        attr_accessor :name

        # @see ArtifactStateTemplate#create
        attr_accessor :code

        # @see ArtifactStateTemplate#create
        attr_accessor :description

        # @see ArtifactStateTemplate#create
        attr_accessor :type

        # @see ArtifactStateTemplate#create
        attr_accessor :entry_state

        # @see ArtifactStateTemplate#create
        attr_accessor :icon_uri

        # @see ArtifactStateTemplate#create
        attr_accessor :order

        # @see ArtifactStateTemplate#create
        attr_accessor :create_activity_template

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def type
          attributes[:type]
        end

        def type=(val)
          attributes[:type] = val
        end

        def entry_state
          attributes[:entryState]
        end

        def entry_state=(val)
          attributes[:entryState] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def order
          attributes[:order]
        end

        def order=(val)
          attributes[:order] = val
        end

        def create_activity_template
          attributes[:createActivityTemplate]
        end

        def create_activity_template=(val)
          attributes[:createActivityTemplate] = val
        end

      end
    end

  end
end
