require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Meta Access Role.
    module MetaAccessRole
      # @see MetaAccessRole#create
      class MetaAccessRoleCreate < UU::OS::REST::DTO

        # @see MetaAccessRole#create
        attr_accessor :data

        # @see MetaAccessRole#create
        attr_accessor :name

        # @see MetaAccessRole#create
        attr_accessor :code

        # @see MetaAccessRole#create
        attr_accessor :description

        # @see MetaAccessRole#create
        attr_accessor :security_level

        # @see MetaAccessRole#create
        attr_accessor :icon_uri

        # @see MetaAccessRole#create
        attr_accessor :default_name

        # @see MetaAccessRole#create
        attr_accessor :default_code

        # @see MetaAccessRole#create
        attr_accessor :default_icon_uri

        # @see MetaAccessRole#create
        attr_accessor :default_security_level

        # @see MetaAccessRole#create
        attr_accessor :default_searchable_in_territory

        # @see MetaAccessRole#create
        attr_accessor :import_life_cycle_template

        # @see MetaAccessRole#create
        attr_accessor :import_property_templates

        # @see MetaAccessRole#create
        attr_accessor :import_sheet_templates

        # @see MetaAccessRole#create
        attr_accessor :import_properties

        # @see MetaAccessRole#create
        attr_accessor :import_sheets

        # @see MetaAccessRole#create
        attr_accessor :import_attachments

        # @see MetaAccessRole#create
        attr_accessor :import_meta_permissions

        # @see MetaAccessRole#create
        attr_accessor :import_permissions

        # @see MetaAccessRole#create
        attr_accessor :import_masks

        # @see MetaAccessRole#create
        attr_accessor :import_use_cases

        # @see MetaAccessRole#create
        attr_accessor :competent_role_uri

        # @see MetaAccessRole#create
        attr_accessor :reference_map

        # @deprecated Input value is ignored, nil is always assumed.
        attr_accessor :default_artifact_type

        # Indicates whether the primarily displayed content of the meta access role is component content.
        attr_accessor :component_content

        # @see MetaAccessRole#create
        attr_accessor :default_component_content
        # @deprecated Always returns nil.
        def default_artifact_type
          nil
        end

        # @deprecated Input value is ignored, nil is always assumed.
        def default_artifact_type=(val)
        end

        def data
          attributes[:data]
        end

        def data=(val)
          if val
            attributes[:data] = UU::OS::REST::BinaryValue.new(val)
          else
            attributes[:data] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def default_name
          attributes[:defaultName]
        end

        def default_name=(val)
          attributes[:defaultName] = val
        end

        def default_code
          attributes[:defaultCode]
        end

        def default_code=(val)
          attributes[:defaultCode] = val
        end

        def default_icon_uri
          attributes[:defaultIconUri]
        end

        def default_icon_uri=(val)
          if val
            attributes[:defaultIconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:defaultIconUri] = nil
          end
        end

        def default_security_level
          attributes[:defaultSecurityLevel]
        end

        def default_security_level=(val)
          attributes[:defaultSecurityLevel] = val
        end

        def default_searchable_in_territory
          attributes[:defaultSearchableInTerritory]
        end

        def default_searchable_in_territory=(val)
          attributes[:defaultSearchableInTerritory] = val
        end

        def import_life_cycle_template
          attributes[:importLifeCycleTemplate]
        end

        def import_life_cycle_template=(val)
          attributes[:importLifeCycleTemplate] = val
        end

        def import_property_templates
          attributes[:importPropertyTemplates]
        end

        def import_property_templates=(val)
          attributes[:importPropertyTemplates] = val
        end

        def import_sheet_templates
          attributes[:importSheetTemplates]
        end

        def import_sheet_templates=(val)
          attributes[:importSheetTemplates] = val
        end

        def import_properties
          attributes[:importProperties]
        end

        def import_properties=(val)
          attributes[:importProperties] = val
        end

        def import_sheets
          attributes[:importSheets]
        end

        def import_sheets=(val)
          attributes[:importSheets] = val
        end

        def import_attachments
          attributes[:importAttachments]
        end

        def import_attachments=(val)
          attributes[:importAttachments] = val
        end

        def import_meta_permissions
          attributes[:importMetaPermissions]
        end

        def import_meta_permissions=(val)
          attributes[:importMetaPermissions] = val
        end

        def import_permissions
          attributes[:importPermissions]
        end

        def import_permissions=(val)
          attributes[:importPermissions] = val
        end

        def import_masks
          attributes[:importMasks]
        end

        def import_masks=(val)
          attributes[:importMasks] = val
        end

        def import_use_cases
          attributes[:importUseCases]
        end

        def import_use_cases=(val)
          attributes[:importUseCases] = val
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def reference_map
          attributes[:referenceMap]
        end

        def reference_map=(val)
          attributes[:referenceMap] = val
        end

        def component_content
          attributes[:componentContent]
        end

        def component_content=(val)
          attributes[:componentContent] = val
        end

        def default_component_content
          attributes[:defaultComponentContent]
        end

        def default_component_content=(val)
          attributes[:defaultComponentContent] = val
        end

      end
    end

  end
end
