require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Meta Permission.
    module MetaPermission
      # @see MetaPermission#create_mask
      class MetaPermissionCreateMask < UU::OS::REST::DTO

        # @see MetaPermission#create_mask
        attr_accessor :name

        # @see MetaPermission#create_mask
        attr_accessor :code

        # @see MetaPermission#create_mask
        attr_accessor :description

        # @see MetaPermission#create_mask
        attr_accessor :data

        # @see MetaPermission#create_mask
        attr_accessor :default_mask

        # @see MetaPermission#create_mask
        attr_accessor :labels
        def data
          attributes[:data]
        end

        def data=(val)
          if val
            attributes[:data] = UU::OS::REST::BinaryValue.new(val)
          else
            attributes[:data] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def default_mask
          attributes[:defaultMask]
        end

        def default_mask=(val)
          attributes[:defaultMask] = val
        end
        
        def labels
          attributes[:labels]
        end

        def labels=(val)
          attributes[:labels] = val
        end

      end
    end

  end
end

