require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Permission.
    module Permission
      # DTO containing attributes of the authority.
      class PermissionGetAuthorityListItem < UU::OS::REST::DTO

        # UESURI of the object for which the authority has granted permissions.
        attr_accessor :uri

        # UESURI of the authority.
        attr_accessor :authority_uri

        # Name of the authority.
        attr_accessor :authority_name

        # UESURI of the Permission Mask.
        attr_accessor :mask_uri

        # Name of the Permission Mask.
        attr_accessor :mask_name

        # Labels of a the Permission Masks.
        attr_accessor :mask_labels
        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def authority_uri
          attributes[:authorityUri]
        end

        def authority_uri=(val)
          if val
            attributes[:authorityUri] = UU::OS::UESURI.new(val)
          else
            attributes[:authorityUri] = nil
          end
        end

        def authority_name
          attributes[:authorityName]
        end

        def authority_name=(val)
          attributes[:authorityName] = val
        end

        def mask_uri
          attributes[:maskUri]
        end

        def mask_uri=(val)
          if val
            attributes[:maskUri] = UU::OS::UESURI.new(val)
          else
            attributes[:maskUri] = nil
          end
        end

        def mask_name
          attributes[:maskName]
        end

        def mask_name=(val)
          attributes[:maskName] = val
        end

        def mask_labels
          attributes[:maskLabels]
        end

        def mask_labels=(val)
          attributes[:maskLabels] = val
        end

      end
    end

  end
end