require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module PersonalRole
      class PersonalRoleCreate < UU::OS::REST::DTO
                # @see PersonalRole#create
                attr_accessor :meta_artifact_uri
             
                # @see PersonalRole#create
                attr_accessor :first_name
        
                # @see PersonalRole#create
                attr_accessor :surname

                # @see PersonalRole#create
                attr_accessor :access_code1
        
                # @see PersonalRole#create
                attr_accessor :access_code2
                
                # @Deprecated @see PersonalRole#create
                attr_accessor :grant_all_from_organizational_unit  
                
                # @see PersonalRole#create
                attr_accessor :searchable_in_territory

                # @see PersonalRole#create
                attr_accessor :security_clearance
                
                # @see PersonalRole#create
                attr_accessor :security_level                   
        
                # @see PersonalRole#create
                attr_accessor :code
        
                # @see PersonalRole#create
                attr_accessor :description
        
                # @see PersonalRole#create
                attr_accessor :competent_role_uri
        
                # @see PersonalRole#create
                attr_accessor :component_content                
        
                # @see PersonalRole#create
                attr_accessor :icon_uri
                               
                # @see PersonalRole#create
                attr_accessor :avatar_uri
                
                # @see PersonalRole#create
                attr_accessor :universe_id

                # @see PersonalRole#create
                attr_accessor :external_access_code1_validation
        
                
                def meta_artifact_uri
                  attributes[:metaArtifactUri]
                end
        
                def meta_artifact_uri=(val)
                  if val
                    attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
                  else
                    attributes[:metaArtifactUri] = nil
                  end
                end
           
                def first_name
                  attributes[:firstName]
                end
        
                def first_name=(val)
                  attributes[:firstName] = val
                end
        
                def surname
                  attributes[:surname]
                end
        
                def surname=(val)
                  attributes[:surname] = val
                end
        
                def code
                  attributes[:code]
                end
        
                def code=(val)
                  attributes[:code] = val
                end
        
                def description
                  attributes[:description]
                end
        
                def description=(val)
                  attributes[:description] = val
                end
        
                def competent_role_uri
                  attributes[:competentRoleUri]
                end
        
                def competent_role_uri=(val)
                  if val
                    attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
                  else
                    attributes[:competentRoleUri] = nil
                  end
                end
        
                def security_level
                  attributes[:securityLevel]
                end
        
                def security_level=(val)
                  attributes[:securityLevel] = val
                end
        
                def security_clearance
                  attributes[:securityClearance]
                end
        
                def security_clearance=(val)
                  attributes[:securityClearance] = val
                end
        
                def searchable_in_territory
                  attributes[:searchableInTerritory]
                end
        
                def searchable_in_territory=(val)
                  attributes[:searchableInTerritory] = val
                end
        
                def icon_uri
                  attributes[:iconUri]
                end
        
                def icon_uri=(val)
                  if val
                    attributes[:iconUri] = UU::OS::UESURI.new(val)
                  else
                    attributes[:iconUri] = nil
                  end
                end
        
                # @deprecated All From OU will not be used in the new authorization (v4).
                def grant_all_from_organizational_unit
                  attributes[:grantAllFromOrganizationalUnit]
                end
        
                # @deprecated All From OU will not be used in the new authorization (v4).
                def grant_all_from_organizational_unit=(val)
                  attributes[:grantAllFromOrganizationalUnit] = val
                end
                
                def component_content
                  attributes[:componentContent]
                end
               
                def component_content=(val)
                  attributes[:componentContent] = val
                end
                
                def avatar_uri
                  attributes[:avatarUri]
                end
               
                def avatar_uri=(val)
                  attributes[:avatarUri] = val
                end
                
                def access_code1
                  attributes[:accessCode1]
                end
               
                def access_code1=(val)
                  attributes[:accessCode1] = val
                end
                
                def access_code2
                  attributes[:accessCode2]
                end
               
                def access_code2=(val)
                  attributes[:accessCode2] = val
                end
                
                def universe_id
                  attributes[:universeId]
                end

                def universe_id=(val)
                  attributes[:universeId] = val
                end

                def external_access_code1_validation
                  attributes[:externalAccessCode1Validation]
                end

                def external_access_code1_validation=(val)
                  attributes[:externalAccessCode1Validation] = val
                end
      end
    end
  end
end