require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module PersonalRole
      class PersonalRoleRelocate < UU::OS::REST::DTO
        # @see PersonalRole#relocate
        attr_accessor :location_uri

        # @see PersonalRole#relocate
        attr_accessor :meta_artifact_uri

        # @Deprecated @see PersonalRole#relocate
        attr_accessor :grant_all_from_organizational_unit

        # @see PersonalRole#relocate
        attr_accessor :searchable_in_territory

        # @see PersonalRole#relocate
        attr_accessor :security_clearance

        # @see PersonalRole#relocate
        attr_accessor :security_level

        # @see PersonalRole#relocate
        attr_accessor :code

        # @see PersonalRole#relocate
        attr_accessor :competent_role_uri
        def location_uri
          attributes[:locationUri]
        end

        def location_uri=(val)
          if val
            attributes[:locationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:locationUri] = nil
          end

        end

        def meta_artifact_uri
          attributes[:metaArtifactUri]
        end

        def meta_artifact_uri=(val)
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def security_clearance
          attributes[:securityClearance]
        end

        def security_clearance=(val)
          attributes[:securityClearance] = val
        end

        def searchable_in_territory
          attributes[:searchableInTerritory]
        end

        def searchable_in_territory=(val)
          attributes[:searchableInTerritory] = val
        end

        # @deprecated All From OU will not be used in the new authorization (v4).
        def grant_all_from_organizational_unit
          attributes[:grantAllFromOrganizationalUnit]
        end

        # @deprecated All From OU will not be used in the new authorization (v4).
        def grant_all_from_organizational_unit=(val)
          attributes[:grantAllFromOrganizationalUnit] = val
        end
      end
    end
  end
end