require 'uu/os/rest/dto'

module UU
  module OS
      module Property

        class PropertySetAttributes < UU::OS::REST::DTO

          # The new name of the property. When nil is set, the name is not modified.
          attr_accessor :name

          # The new code of the property. When nil is set, the code is not modified. he code
          # must be unique in an artifact scope, otherwise the setAttributes command fails.
          attr_accessor :code

          # The new description of the property. When nil is set, the description is not modified.
          attr_accessor :description

          def name 
            attributes[:name]
          end

          def name=(val) 
            attributes[:name] = val
          end

          def code 
            attributes[:code]
          end

          def code=(val) 
            attributes[:code] = val
          end

          def description 
            attributes[:description]
          end

          def description=(val) 
            attributes[:description] = val
          end

        end

      end
    end

end
