module UU
  module OS
      module Property

        class PropertyType

          # Real number.
          NUMBER = 'NUMBER'

          # Date (with the day precision, time information is ignored).
          DATE = 'DATE'

          # Short text (limited to 250 characters).
          SHORT_TEXT = 'SHORT_TEXT'

          # Text (limited to 4000 characters).
          TEXT = 'TEXT' # 21-1 Neni limit jen 2000 znaku?

          # Reference to an artifact or an aggregated object in UU. Only in the same territory.
          REFERENCE = 'REFERENCE'

          # Reference to an artifact or an aggregated object in UU. Territory is not important.
          INTERTERRITORIAL_REFERENCE = 'INTERTERRITORIAL_REFERENCE'

          # URL (The value is represented by String).
          URL = 'URL'

          # Arbitrary binary data (The value is represented by BinaryValue).
          BINARY = 'BINARY'

          # Contains image binary data and meta data (The value is represented by BinaryValue).
          IMAGE = 'IMAGE'

          # Unknown type. The value is not available.
          UNKNOWN = 'UNKNOWN'

        end

      end
    end

end
